package com.lediglesesalplass;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;

import android.os.AsyncTask;
import android.util.Log;

public class GetLogin extends AsyncTask<Void, Void, DefaultHttpClient>{

	// Username and password is censored in source code, use the pre-made .apk file to run application
	private static final String username = "CENSORED";
	private static final String password = "CENSORED";
	private static DefaultHttpClient httpClient; 

	private static final String TAG = "getlogin"; // Used as tag for searching in logcat

	public static URI uri_login; // uri til login page


	@Override
	protected DefaultHttpClient doInBackground(Void... arg0) {

		String result = "";

		HttpParams params = new BasicHttpParams(); 
		HttpConnectionParams.setConnectionTimeout(params, 10000);

		SchemeRegistry schReg = new SchemeRegistry();
		schReg.register(new Scheme("https", SSLSocketFactory.getSocketFactory(), 443)); 
		schReg.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
		ClientConnectionManager conMgr = new ThreadSafeClientConnManager(params, schReg);

		BasicCookieStore cookieStore = new BasicCookieStore();
		httpClient = new DefaultHttpClient(conMgr, params);
		httpClient.setCookieStore(cookieStore);

		List<NameValuePair> postParams = new ArrayList<NameValuePair>(); //username and password stored here
		postParams.add(new BasicNameValuePair("username", username ));
		postParams.add(new BasicNameValuePair("password", password ));

		try {
			uri_login = new URI("https","analytics.mazemap.com", "/api/login/", null );					

		} catch (URISyntaxException e) {
			Log.e(TAG, "URI syntax failed: "+ e.toString());
		}

		HttpPost httpPost = new HttpPost(uri_login);

		try {
			UrlEncodedFormEntity entity = new UrlEncodedFormEntity(postParams);

			httpPost.setEntity(entity);
			
		} catch (UnsupportedEncodingException e) {
			Log.e(TAG, "UnsupportedEncodingException: " + e.getMessage());
		}

		// execute httpPost
		try {
			HttpResponse httpResponse = httpClient.execute(httpPost); 
			Log.i(TAG, "httpResponse utfrt! (innlogging)");	        	        
			StatusLine statusLine = httpResponse.getStatusLine();
			int code = statusLine.getStatusCode(); 
			if( code == 200 || code == 201 || code == 202){
				Log.i(TAG, "Login OK!");
				return httpClient;
			} else{
				return null;
			}

		} catch (ClientProtocolException e) {
			Log.e(TAG, "ClientProtocolException: " + e.toString());
		} catch (IOException e) {
			Log.e(TAG, "IOException: " + e.toString());
		}
		return null;		
	}

}
