package com.lediglesesalplass;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.concurrent.ExecutionException;
import android.os.Bundle;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.GradientDrawable;
import android.text.SpannableString;
import android.text.style.ForegroundColorSpan;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.TextView.BufferType;

@SuppressLint("SimpleDateFormat")
public class InformationActivity extends Activity {

	private final String TAG = "InformationActivity";
	private float checkColor;
	private int roomId;
	private boolean checkFav;
	private Spinner mySpinner;
	private ArrayAdapter<String> sAdapter;
	private ListView infoList, titleList;
	private TitleAdapter tAdapter;

	private ArrayList<String> stringsForSpinner; // Denne lista lista skal inneholde dager og dato lagret som string, 7dager bakover i tid 
	private ArrayList<Date> datesForSpinner; // Samme som over, bare med Date-objekter
	private ArrayList<DeviceTimestamp> statistics; // Denne listen skal inneholde objekter med klokkeslett og ant. devices 
	private InformationAdapter iAdapter;
	private ArrayList<String> fakeList;



	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_information);

		stringsForSpinner = new ArrayList<String>();
		datesForSpinner = new ArrayList<Date>();
		statistics = new ArrayList<DeviceTimestamp>();

		Intent intent = getIntent();
		Bundle bundle = intent.getExtras();	
		ReadingRoom room = Model.getRoomByID(bundle.getInt("roomID"));
		this.roomId = room.getId();
		checkFav = room.getFavorite();


		// Legger inn riktige datoer i spinner
		this.putDatesInSpinner();

		// Tittelnavn
		TextView titleInformation = (TextView) findViewById(R.id.titleInformation);
		titleInformation.setText(""+room.getName());

		// Bygningsnavn
		TextView infoBuilding = (TextView) findViewById(R.id.infoBuilding);
		String editString = "";
		if (room.getBuilding().length() > 13){
			editString = room.getBuilding().replaceAll(" ", "\n");
		} else {
			editString = room.getBuilding();
		}
		SpannableString buildingTextEdit = new SpannableString("Building: "+editString);
		buildingTextEdit.setSpan(new ForegroundColorSpan(Color.parseColor("#ffa500")), 0, 9, 0);
		infoBuilding.setText(buildingTextEdit, BufferType.SPANNABLE);

		// Etasje
		TextView infoFloor = (TextView) findViewById(R.id.infoFloor);
		SpannableString floorTextEdit = new SpannableString("Floor: "+room.getFloorName());
		floorTextEdit.setSpan(new ForegroundColorSpan(Color.parseColor("#ffa500")), 0, 6, 0);
		infoFloor.setText(floorTextEdit, BufferType.SPANNABLE);

		// Kapasitet
		TextView infoCapasity = (TextView) findViewById(R.id.infoCapasity);
		SpannableString capacityTextEdit = new SpannableString("/ "+room.getCapacity());
		capacityTextEdit.setSpan(new ForegroundColorSpan(Color.BLACK), 0, 0, 0);
		infoCapasity.setText(capacityTextEdit, BufferType.SPANNABLE);

		// Tid
		TextView infoTimeStamp = (TextView) findViewById(R.id.infoUpdateTime);
		SpannableString timestampTextEdit = new SpannableString("Last measured: "+room.getTimestamp());
		timestampTextEdit.setSpan(new ForegroundColorSpan(Color.parseColor("#ffa500")), 0, 14, 0);
		infoTimeStamp.setText(timestampTextEdit, BufferType.SPANNABLE);

		// Antall personer
		TextView infoPeople = (TextView) findViewById(R.id.infoPeople);
		SpannableString devicesTextEdit = new SpannableString("Occupied: "+room.getDevices()+" ");
		devicesTextEdit.setSpan(new ForegroundColorSpan(Color.parseColor("#ffa500")), 0, 9, 0);
		infoPeople.setText(devicesTextEdit, BufferType.SPANNABLE);

		// Studieprogram tittelen
		TextView studyProgramTitle = (TextView) findViewById(R.id.additionalInfo);
		SpannableString studyProgramTextEdit = new SpannableString("Available for:");
		studyProgramTextEdit.setSpan(new ForegroundColorSpan(Color.parseColor("#ffa500")), 0, 14, 0);
		studyProgramTitle.setText(studyProgramTextEdit, BufferType.SPANNABLE);

		// Map
		ImageView mapButton = (ImageView) findViewById(R.id.map);
		mapButton.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				Intent intent = new Intent(getBaseContext(), Map.class);
				intent.putExtra("roomID", roomId);
				startActivity(intent);
				// TODO Auto-generated method stub	
			}

		});

		// Studieprogrammene
		TextView studyProgram = (TextView) findViewById(R.id.additionalInfo2);
//		TextView studyProgram2 = (TextView) findViewById(R.id.additionalInfo3);
//		TextView studyProgram3 = (TextView) findViewById(R.id.additionalInfo4);
//		TextView studyProgram4 = (TextView) findViewById(R.id.additionalInfo5);
//		TextView studyProgram5 = (TextView) findViewById(R.id.additionalInfo6);
//		TextView studyProgram6 = (TextView) findViewById(R.id.additionalInfo7);
		
		SpannableString studiesTextEdit;
		GradientDrawable drawable = new GradientDrawable();
		drawable.setCornerRadius(20);
		drawable.setColor(Color.parseColor("#33FF66")); // Green color
		studyProgram.setBackgroundDrawable(drawable);
		
		if(room.getBuilding().equals("IT-bygget")){
			studiesTextEdit = new SpannableString(" Room closed! ");
			drawable.setColor(Color.parseColor("#FF0000")); //Red color
		}else{
			studiesTextEdit = new SpannableString(" All ");
		}
//		SpannableString studiesTextEdit2 = new SpannableString(" MAAR ");
//		SpannableString studiesTextEdit3 = new SpannableString(" MTIT ");
//		SpannableString studiesTextEdit4 = new SpannableString(" MTDT ");
//		SpannableString studiesTextEdit5 = new SpannableString(" MTPROD ");
//		SpannableString studiesTextEdit6 = new SpannableString(" MTKJ ");
		//BIT, NANO MTKOM, MTDT, MTIT, MTPROD, BGEOL, MGEOL, MSAPPMA, MAAR, MAAR2, MTMART, MTEL, MIMART, MTENERG, MIENERG, MTDESIG, MIDESIG, MTKJ, MIIK, MTING, MSN1, MTNANO
		studyProgram.setText(studiesTextEdit, BufferType.SPANNABLE);
//		studyProgram2.setText(studiesTextEdit2, BufferType.SPANNABLE);
//		studyProgram3.setText(studiesTextEdit3, BufferType.SPANNABLE);
//		studyProgram4.setText(studiesTextEdit4, BufferType.SPANNABLE);
//		studyProgram5.setText(studiesTextEdit5, BufferType.SPANNABLE);
//		studyProgram6.setText(studiesTextEdit6, BufferType.SPANNABLE);

//		GradientDrawable drawable2 = new GradientDrawable();
//		GradientDrawable drawable3 = new GradientDrawable();
//		GradientDrawable drawable4 = new GradientDrawable();
//		GradientDrawable drawable5 = new GradientDrawable();
//		GradientDrawable drawable6 = new GradientDrawable();
//		drawable2.setCornerRadius(20);
//		drawable3.setCornerRadius(20);
//		drawable4.setCornerRadius(20);
//		drawable5.setCornerRadius(20);
//		drawable6.setCornerRadius(20);
//		drawable2.setColor(Color.parseColor("#33FFFF"));
//		drawable3.setColor(Color.parseColor("#FF6600"));
//		drawable4.setColor(Color.parseColor("#33FF66"));
//		drawable5.setColor(Color.parseColor("#FF6699"));
//		drawable6.setColor(Color.parseColor("#660099"));
//		studyProgram2.setBackgroundDrawable(drawable2);
//		studyProgram3.setBackgroundDrawable(drawable3);
//		studyProgram4.setBackgroundDrawable(drawable4);
//		studyProgram5.setBackgroundDrawable(drawable5);
//		studyProgram6.setBackgroundDrawable(drawable6);

		// Epost
		TextView email = (TextView) findViewById(R.id.email);
		final String eName = room.getName();
		final String eBuil = room.getBuilding();
		final String eTime = room.getTimestamp();

		email.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				Intent intent = new Intent(android.content.Intent.ACTION_SEND);
				intent.putExtra(android.content.Intent.EXTRA_SUBJECT, "Report wrong data for reading room: "+ eName + ", building: " + eBuil + ", time: " + eTime);
				intent.putExtra(android.content.Intent.EXTRA_TEXT, "");
				intent.putExtra(android.content.Intent.EXTRA_EMAIL, new String[] {"hoangtha@stud.ntnu.no", "trond.t@gmail.com"});
				intent.setType("message/rfc822");
				startActivity(Intent.createChooser(intent, "Choose an Email app to report wrong data"));
			}
		});

		// Sette riktig farge p prosentikonene
		ImageView capacitySignal = (ImageView) findViewById(R.id.infoCapacitySignal);
		checkColor = room.getPercentInt();
		if(checkColor <= 0)
			capacitySignal.setImageResource(R.drawable.green0_115px);

		if (checkColor >= 1 && checkColor <= 30)
			capacitySignal.setImageResource(R.drawable.green25_115px);

		if (checkColor >= 31 && checkColor <= 60)
			capacitySignal.setImageResource(R.drawable.green50_115px);

		if (checkColor >= 61 && checkColor <=90)
			capacitySignal.setImageResource(R.drawable.yellow75_115px);

		if (checkColor >= 91 || room.getBuilding().equals("IT-bygget"))
			capacitySignal.setImageResource(R.drawable.red100_115px);
		// Fikse prosent p boxene
		TextView percentInBox = (TextView) findViewById(R.id.percentTest2);
		percentInBox.setText(room.getPercentInt()+"%");

		// Spinner to select which day to get statistics
		mySpinner = (Spinner) findViewById(R.id.dropDownMenu);
		sAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, stringsForSpinner);
		sAdapter.setDropDownViewResource(android.R.layout.simple_dropdown_item_1line);
		mySpinner.setAdapter(sAdapter);
		iAdapter = new InformationAdapter(getBaseContext(), R.layout.information_item, statistics );
		try {
			// Finner lista
			this.infoList = (ListView) findViewById(R.id.infoListe);
			this.infoList.setAdapter(iAdapter);
			infoList.setOnItemClickListener(null);
		} catch (Exception e) {
			Log.e(TAG, "setting av iAdapter feilet: "+ e.toString());			
		}		

		// FakeList
		fakeList = new ArrayList<String>();
		fakeList.add("1 row");

		// Tittel lista
		tAdapter = new TitleAdapter(getBaseContext(), R.layout.title_adapter, fakeList);
		titleList = (ListView) findViewById(R.id.titleList);
		titleList.setAdapter(tAdapter);
		titleList.setOnItemClickListener(null);
		mySpinner.setOnItemSelectedListener(new OnItemSelectedListener() {
			@Override

			public void onItemSelected(AdapterView<?> adapterView, View view,
					int position, long id) {
				Date date = datesForSpinner.get(position);
				statistics.clear();
				iAdapter.clear();
				iAdapter.notifyDataSetInvalidated();
				SimpleDateFormat formatter = new SimpleDateFormat("dd.MM EEEE"); // dato.mned dag
				Toast.makeText(getBaseContext(), "You have selected: "+formatter.format(date), Toast.LENGTH_SHORT).show();

				if (Utility.isNetworkConnected(getBaseContext())){
					try {						
						statistics.addAll(Model.getStatisticsFromAPI(date, roomId));					
						iAdapter.notifyDataSetChanged();

					} catch (InterruptedException e) {
						Log.e(TAG, "Oppdatering av statistics ble avbrutt: " + e.toString());
					} catch (ExecutionException e) {
						Log.e(TAG, "Oppdatering av statistics feilet: " + e.toString());					
					}
					iAdapter.notifyDataSetChanged();
				} else {
					Toast.makeText(getBaseContext(), "No internet connection", Toast.LENGTH_LONG).show();
				} 


			} // end OnItemSelected
			@Override
			public void onNothingSelected(AdapterView<?> adapter) {  }

		}); //end setOnItemSelectedListener


		// Legger til favoritt eller fjerner favoritt
		final ImageView notfavorite = (ImageView) findViewById(R.id.notfavorite);
		final ImageView favorite = (ImageView) findViewById(R.id.favorite);
		favorite.setVisibility(View.GONE); 
		if (checkFav)
			favorite.setVisibility(View.VISIBLE);
		// Legger favoritt til lista
		notfavorite.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Toast.makeText(getApplicationContext(), "Added to your favorite list", Toast.LENGTH_SHORT).show();
				v.setVisibility(View.GONE);
				favorite.setVisibility(View.VISIBLE);
				Model.addFavorite(roomId);
			}
		});

		// Fjerner favoritt fra lista
		favorite.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Toast.makeText(getApplicationContext(), "Removed from your favorite list", Toast.LENGTH_SHORT).show();
				v.setVisibility(View.GONE);
				notfavorite.setVisibility(View.VISIBLE);
				Model.removeFavorite(roomId);
			}
		});

		// Up eller Home knappen
		final ImageView upButton = (ImageView) findViewById(R.id.upButton);
		upButton.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				onBackPressed();
			}
		});		
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.information, menu);
		return true;
	}

	@Override
	public void onSaveInstanceState(Bundle savedInstanceState){
		savedInstanceState.putInt("roomID", roomId);	
		savedInstanceState.putBoolean("Boolean", checkFav);
		super.onSaveInstanceState(savedInstanceState);
	}

	@Override
	public void onRestoreInstanceState(Bundle savedInstanceState){
		super.onRestoreInstanceState(savedInstanceState);		
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_MENU) {
			Intent intent = new Intent(this, SettingsActivity.class);
			startActivity(intent);
			return false;
		}
		return super.onKeyDown(keyCode, event);
	}

	
	// This method calculates which dates that will be shown in spinner
	// Today's date plus 14 days backwards in time will be displayed 
	public void putDatesInSpinner(){
		stringsForSpinner.clear();
		datesForSpinner.clear();

		SimpleDateFormat formatter = new SimpleDateFormat("dd.MM EEEE"); // dato.mned dag
		Calendar cal = Calendar.getInstance();

		Date date = cal.getTime();
		String stringDate = formatter.format(date);
		stringsForSpinner.add(stringDate);
		datesForSpinner.add(date);

		for(int i=1; i<=14; i++){
			Calendar tempCal = Calendar.getInstance();
			tempCal.add(Calendar.DAY_OF_YEAR, -i);
			Date tempDate = tempCal.getTime();
			datesForSpinner.add(tempDate);
			String tempString = formatter.format(tempDate);
			stringsForSpinner.add(tempString);
		}
	}
}
