package com.lediglesesalplass;

import android.os.Bundle;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Intent;
import android.view.Menu;
import android.webkit.GeolocationPermissions;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;

@SuppressLint("SetJavaScriptEnabled")
public class Map extends Activity {

	// This method prevents Android 2.3 from opening search results in browser
	public class GeoWebViewClient extends WebViewClient {
        @Override
        public boolean shouldOverrideUrlLoading(WebView view, String url) {           
            
        	return true;
        }
    }
	public class GeoWebChromeClient extends WebChromeClient {
        @Override
        public void onGeolocationPermissionsShowPrompt(String origin, GeolocationPermissions.Callback callback) {
            // Always grant permission since the app itself requires location permission and the user has therefore already granted it
            callback.invoke(origin, true, true); 
        }
    }
	
	WebView wv;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_map);

		Intent intent = getIntent();
		Bundle bundle = intent.getExtras();	
		ReadingRoom room = Model.getRoomByID(bundle.getInt("roomID"));
		final String roomName = room.getName().replaceAll(" ", "%20");
		final String buildingName = room.getBuilding().replaceAll(" ", "%20");

		wv = (WebView) findViewById(R.id.webviewmap);				
		wv.getSettings().setJavaScriptCanOpenWindowsAutomatically(true);		
		wv.getSettings().setBuiltInZoomControls(true);
		wv.setWebViewClient(new GeoWebViewClient(){});	
		wv.getSettings().setJavaScriptEnabled(true);				
		wv.getSettings().setGeolocationEnabled(true);
		wv.setWebChromeClient(new GeoWebChromeClient());
		
		wv.getSettings().setLoadWithOverviewMode(true);
//		wv.getSettings().setSupportMultipleWindows(true); //possible source of error
//		wv.getSettings().setUseWideViewPort(true);  //possible source of error	    
		wv.getSettings().setDomStorageEnabled(true);
		wv.getSettings().setSupportZoom(true);
		wv.getSettings().setAllowFileAccess(true);
		wv.getSettings().setAppCacheEnabled(true);
		wv.getSettings().setCacheMode(WebSettings.LOAD_DEFAULT);

		wv.loadUrl("http://use.mazemap.com/?&v=1&campusid=1&search="+roomName+"%20"+buildingName);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.map, menu);
		return true;
	}
}
