package com.lediglesesalplass;

// ReadingSpot objekt sine datatyper
public class ReadingRoom {
	private int id; 		// room-id, brukes hvis man skal hente data fra feks. /api/campus/1/regions/11624/
	private int floorID; 	// used to compare data gathered from analytics api with the mazemap api, to find right building name
	private int capacity; 	// number of desks in a room
	private int devices; 	// number of people in a room
	private int distance; 	// distance in meters between users' device and readingroom 
	private String roomName; 
	private String buildingName;
	private String floorName;	
	private String timestamp;
	private double latitude;
	private double longitude;
	private boolean favorite;

	public ReadingRoom(int roomID, String roomName, String floorName, int floorId, double latitude, double longitude) {	
		this.id = roomID;
		this.roomName = roomName;
		this.floorName = floorName;
		this.floorID = floorId;
		this.capacity = 999;
		this.latitude = latitude;
		this.longitude = longitude;

		this.devices = -1;
		this.timestamp = "NA";
		this.favorite = false;		
		this.buildingName = "";
		this.distance= 0; 
	}	


	public int getFloorId(){
		return this.floorID;
	}

	// Hente roomID
	public int getId(){
		return this.id;
	}

	// Hente navn
	public String getName(){
		return roomName;			
	}

	// Sette navn
	public void setName(String name){
		this.roomName = name;
	}

	// Hente bygning
	public String getBuilding(){
		return buildingName;
	}

	// Sette bygning
	public void setBuildingName(String building){
		this.buildingName = building;
	}	

	// Hente etasje
	public String getFloorName(){
		return floorName;
	}

	// Sette etasje
	public void setFloor(String floorName){
		this.floorName = floorName;
	}

	// Hente kapasitet
	public int getCapacity(){
		return capacity;
	}		

	// Sette kapasitet
	public void setCapacity(int capacity){
		this.capacity = capacity;
	}

	// Hente antall enheter
	public int getDevices(){
		return devices;
	}

	// Sette antall enheter
	public void setDevices(int devices, String timestamp){
		this.devices = devices;
		this.timestamp = timestamp;
	}

	public double getStatus(){
		if (devices > 0){
			return (capacity/devices);			
		}
		return 0.0;
	}

	// Hente timestamp
	public String getTimestamp(){
		return timestamp;
	}

	// Legge til som favoritt
	public void setFavorite(){
		this.favorite = true;
	}

	// Hente status p objektet
	public boolean getFavorite(){
		return this.favorite;
	}

	// Fjerne som favoritt
	public void removeFavorite(){
		this.favorite = false;
	}
	
	public int getDistance(){
		return this.distance;
	}
	public void setDistance(int distance){
		if(distance > 0){
			this.distance = distance;
		}
		else{
			this.distance = -1; 
		}
	}
	
	public double getLongitude(){
		return this.longitude;
	}
	public double getLatitude(){
		return this.latitude;
	}

	// Method to calculate filling percentage
	public float getPercent(){
		float percent = this.devices * 100f / this.capacity;
		return percent;
	}
	// Retrives percentage as integer
	public int getPercentInt(){
		int prosent = this.devices * 100 / this.capacity;
		if (prosent < 0)
			return 0;
		return prosent;
	}

}
